



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>SQL SERVER中架构的理解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">SQL SERVER中架构的理解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 13:45:32 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
</div>
<div>
<p>在sqlserver 2005中，可能大家在工作或学习的时候会经常发现这样一些问题，你使用一个账户在数据库中创建了一张表，却发现你自己创建的表却没有修改和查询的权限，这是一件很郁闷的事情，在sqlserver2000中却不存在这样的问题，那为什么在2005中会出现这样的事情，这样的设置可以带来哪些好处？其实导致这一问题的原因主要在于2005中多了一个新的概念&mdash;架构。</p>
<p>首先我们来看一下msdn中对架构的定义:架构(Schema)是形成单个命名空间的数据库实体的集合。命名空间是一个集合，其中每个元素的名称都是唯一的。在这里，我们可以将架构看成一个存放数据库中对象的一个容器。</p>
<p>架构实际上在sqlserver2000中就已经存在，当我们使用查询分析器去查询一个表的时候，一个完整的表的名称应该包括服务器名.数据库名.用户名.对象名，而在sqlserver2005中一个表的完全限定名称应该为服务器名.数据库名.架构名.对象名</p>
<p>在2000中，假如有一个账户tt在test数据库中创建了一张表table1的时候，在服务器上对查询的语句应为select * from test.tt.table1,也就是说，在sqlserver 2000中一张表所属的架构默认就是表的创建者的登录名称，用户可以和修改他所创建的所有数据库对象。但在2005中已经将用户和其创建对象所属架构的关联取消了，而加入了一个全新的架构体系，这样做的优点主要在于下面几个方面：</p>
<p>1.&nbsp;&nbsp;多个用户可以通过角色（role）或组（Windows groups）成员关系拥有同一个架构。在2005中，每个数据库中的固定数据库角色都有一个属于自己的架构，如果我们创建一个表，给它指定的架构名称为db_ddladmin，那么任何一个属于db_ddladmin中的用户都是可以去查询、修改和删除属于这个架构中的表，但是其它不属于这个组的用户是不行的，有一点必须注意，db_dbdatareader组的成员可以查看所有数据库中的表，db_dbdatawriter组成员可以修改所有数据库中的表，db_owner组成员可以对数据库所有表进行所有操作，这几个组的成员可以通过角色获取到在数据库中的特殊权限。</p>
<p>2.&nbsp;&nbsp;删除数据库用户变得极为简单。在 SQL Server 2000 中，用户（User）和架构是隐含关联的，即每个用户拥有与其同名的架构。因此要删除一个用户，必须先删除或修改这个用户所拥有的所有数据库对象，就比如一个员工要离职要删除他的账户的时候，还得将他所创建的表和视图等都删除，影响过大。将架构和对象者分离后就不在存在这样的问题，删除用户的时候，对数据库对象是没有任何影响的。</p>
<p>3.&nbsp;共享缺省架构使得开发人员可以为特定的应用程序创建特定的架构来存放对象，这比仅使用管理员架构（DBO schema）要好。</p>
<p>4.&nbsp;在架构和架构所包含的对象上设置权限（permissions）比以前的版本拥有更高的可管理性。</p>
<p>5.&nbsp;区分不同业务处理需要的对象，例如，我们可以把公共的表设置成pub的架构，把销售相关的设置为sales，这样管理和访问起来更容易.</p>
<p>大多数用户在创建对象的时候习惯直接输入对象名而将对象的架构名称省略，在2005中，会给用户创建的这样的表加上一个缺省的架构，用户如果没有对自己的默认架构做设置，那缺省架构就是dbo，也就是说，如果一个db_ddladmin的成员在数据库中创建一个没有加上架构名称的表，这个表在数据库中的完整名称应该是dbo.表名，创建者在数据库中如果不是属于其它特殊组的成员，是不能对自己创建的表进行任何修改和查询的，那就相当于把自己赚的钱存进了别人的银行卡，自己却取不出来。</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qn5vy2q.html">activity通过onActivityResult间数据交互</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdx4l08.html">Tomcat 开启 SSL</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq125kz9.html">iOS开发遇到的错误 -- Label显示多行文字导致宽度和高度的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/3906yjm9.html">设计模式之Builder （创建者模式）的一些个人理解（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wjpglq.html">（转） TensorFlow深度学习，一篇文章就够了</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vrglj8.html">V&dollar;SGA&lowbar;RESIZE&lowbar;OPS&period;STATUS &equals; ERROR&comma; and MMAN &sol; auto-tuning stops&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1lod39.html">iOS支付宝集成步骤；王刚韧的技术博客</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xvlk08.html">Unity3d 协程的注意问题（新手须注意，老手须加勉）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vog0m8.html">关于中文乱码的解决方法（URL方式）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w7mdlq.html">JavaScript引用类型之Array数组的排序方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zok23vq.html">学习自动化工具gulp</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1v35mq.html">sqlserver跨数据库与跨服务器使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpkeozq.html">CSS学习笔记10 相对定位，绝对定位与固定定位</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jm4g0q.html">nginx根据cookie分流</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj547r9.html">Left-pad</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjyx2e9.html">python 常见异常</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r70158.html">Android--Android Studio 打开ADM报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w0y1rq.html">&lpar;转&rpar;Python3之pickle模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/902y44nq.html">JAVA 从头开始&amp;lt&semi;六&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvll1dq.html">Web 前端性能优化相关内容解析&lbrack;转&rsqb;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwdw0or8.html">LeetCode题解&mdash;&mdash;Roman to Integer</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmg54z9.html">CreateThread函数&amp;amp&semi;amp&semi;&amp;amp&semi;amp&semi;CString&colon;&colon;GetBuffer函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0ld5gq.html">BAT-使用BAT方法删除目录下0KB文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydgokjq.html">sping配置文件中引入properties文件方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd7m1m8.html">CentOS 搭建LNMP服务器和LAMP服务器</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z13xpn9.html">QString 与 QByteArray笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x7ro09.html">&lbrack;转&rsqb;javascript对联广告、漂浮广告封装类，多浏览器兼容</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mdv7eq.html">MVC神韵---你想在哪解脱！（十一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mdvkkq.html">c语言向文件中写入</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnygv08.html">Oracle数据库如何授权收费（Database Licensing）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
